#include "20mhz_delays.h"

void delay_ms(uns16 millisec)
// Delays a multiple of 1ms at 4 MHz using TMR0
{
	#if CLOCK == 20000000
	millisec *= 5;
	#endif

	#if CLOCK == 8000000
	millisec *= 2;
	#endif

	uns8 next = 0;

    OPTION = 2; 					// prescaler divide TMR0 rate by 8
    TMR0 = 2;  						// deduct 2*8 fixed instruction cycles delay

    do {
		next += 125;
		while (TMR0 != next);   	// 125 * 8 = 1000 (= 1 ms)
    } while ( -- millisec != 0);
}

void delay_3us(void) {
	uns8 value = 2;
	while(--value);
}

void delay_5us(void) {
	uns8 value = 6;
	while(--value);
}

void delay_50us(void) {
	uns8 value = 82;
	while(--value);
}

void delay_100us(void) {
	uns8 value = 165;
	while(--value);
}
